package com.inca.npbusi.inf.goods;

import com.inca.np.auth.ClientUserManager;
import com.inca.np.gui.control.CFrame;
import com.inca.np.gui.control.DBTableModel;
import com.inca.npbusi.inf.hov.Zx_su_price_type_hov;
import com.inca.npx.ste.CSteModelAp;
import com.inca.pubsrv.NpbusiDBHelper;
import com.inca.pubsrv.hov.bms_sa_goods_price_hov.Bms_sa_goods_price_hov;
import java.awt.Frame;
import java.awt.HeadlessException;

public class Inf_goods_ste extends CSteModelAp {
   public Inf_goods_ste(CFrame frame) throws HeadlessException {
      super(frame, "货品对码");
   }

   public String getTablename() {
      return "hrp_goods_v";
   }

   public String getSaveCommandString() {
      return "com.inca.npbusi.inf.goods.Inf_goods_ste.保存货品对码";
   }

   protected void on_itemvaluechange(int row, String colname, String value) {
      if (colname.equals("goodsname")) {
         this.setItemValue(row, "operatingid", ClientUserManager.getCurrentUser().getUserid());
         this.setItemValue(row, "operatingperson", ClientUserManager.getCurrentUser().getUsername());
         this.setItemValue(row, "operatingmac", ClientUserManager.getCurrentUser().getMac());
         this.setItemValue(row, "operdate", NpbusiDBHelper.getSysdate());
         this.setItemValue(row, "baseratio", "1");
         this.setItemValue(row, "priceid", "");
         this.getItemValue(row, "goodsid");
         this.getItemValue(row, "yljgbm");
         Bms_sa_goods_price_hov hov = new Bms_sa_goods_price_hov();
         hov.setOtherwheres(" ((customid is null or customid = " + this.getItemValue(row, "yljgbm") + ") and goodsid = " + this.getItemValue(row, "goodsid") + " and entryid=1)");
         DBTableModel model = hov.showDialog((Frame)null, "选择货品价格");
         this.setItemValue(row, "priceid", model.getItemValue(0, "priceid"));
         Zx_su_price_type_hov suhov = new Zx_su_price_type_hov();
         suhov.setOtherwheres("workflag =6 and goodsid=" + this.getItemValue(row, "goodsid") + " and entryid=" + ClientUserManager.getCurrentUser().getEntryid());
         DBTableModel sumodel = suhov.showDialog((Frame)null, "选择货品采购价格");
         this.setItemValue(row, "supriceid", sumodel.getItemValue(0, "priceid"));
         this.doSave();
      }

      super.on_itemvaluechange(row, colname, value);
   }

   public String getHovOtherWheres(int row, String colname) {
      if (colname.equals("goodsid")) {
         return "goodsid not in(select  nvl(goodsid,0) goodsid from hrp_goods where yljgbm=" + this.getItemValue(row, "yljgbm") + " )";
      } else if (colname.equals("priceid")) {
         if (this.getItemValue(row, "goodsid").equals("")) {
            this.warnMessage("提示", "货品未选择，请先对照货品！！");
            return "1>2";
         } else {
            return " ((customid is null or customid = " + this.getItemValue(row, "yljgbm") + ") and goodsid = " + this.getItemValue(row, "goodsid") + " and entryid=1)";
         }
      } else if (colname.equals("supriceid")) {
         if (this.getItemValue(row, "goodsid").equals("")) {
            this.warnMessage("提示", "货品未选择，请先对照货品！！");
            return "1>2";
         } else {
            return "( workflag =6 and goodsid=" + this.getItemValue(row, "goodsid") + " and entryid=" + ClientUserManager.getCurrentUser().getEntryid() + ")";
         }
      } else {
         return super.getHovOtherWheres(row, colname);
      }
   }

   protected String getOtherWheres() {
      String entryid = ClientUserManager.getCurrentUser().getEntryid();
      return " entryid=" + entryid;
   }
}
